//=--------------------------------------------------------------------------=
// RectangleObj.H
//=--------------------------------------------------------------------------=
// Copyright  1995  Microsoft Corporation.  All Rights Reserved.
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
//=--------------------------------------------------------------------------=
//
// the Rectangle object.
//
//
#ifndef _RECTANGLE_H_

#include "AutoObj.H"
#include "AutoSampleInterfaces.H"

class CRectangle : public IRectangle, public CAutomationObject, ISupportErrorInfo {

  public:
    // IUnknown methods
    //
    DECLARE_STANDARD_UNKNOWN();

    // IDispatch methods
    //
    DECLARE_STANDARD_DISPATCH();

    //  ISupportErrorInfo methods
    //
    DECLARE_STANDARD_SUPPORTERRORINFO();

    CRectangle(IUnknown *);
    virtual ~CRectangle();

    // IRectangle methods
    // TODO: copy over the interface methods for IRectangle from
    //       AutoSampleInterfaces.H here.
    //
    STDMETHOD(get_Bottom)(long * plBottom) ;
    STDMETHOD(put_Bottom)(long lBottom) ;
    STDMETHOD(get_Left)(long * plLeft) ;
    STDMETHOD(put_Left)(long lLeft) ;
    STDMETHOD(get_Right)(long * plRight) ;
    STDMETHOD(put_Right)(long lRight) ;
    STDMETHOD(get_Top)(long * plTop) ;
    STDMETHOD(put_Top)(long lTop) ;


    // creation method
    //
    static IUnknown *Create(IUnknown *);

  protected:
    virtual HRESULT InternalQueryInterface(REFIID riid, void **ppvObjOut);

  private:
    // member variables that nobody else gets to look at.
    // TODO: add your member variables and private functions here.
    //
    RECTL m_rect;
};

// TODO: modify anything appropriate in this structure, such as the helpfile
//       name, the version number, etc.
//
DEFINE_AUTOMATIONOBJECT(Rectangle,
    &CLSID_Rectangle,
    "Rectangle",
    CRectangle::Create,
    1,
    &IID_IRectangle,
    "Rectangle.Hlp");


#define _RECTANGLE_H_
#endif // _RECTANGLE_H_
